.HIROM

.SNESHEADER
 ID    "CTSN"
 NAME  "CHRONO TRIGER SNSF   "
 HIROM
 FASTROM
 CARTRIDGETYPE $00
 ROMSIZE $0A
 SRAMSIZE $00
 COUNTRY $00
 LICENSEECODE $33
 VERSION $00
.ENDSNES

.MEMORYMAP
 SLOTSIZE $8000
 DEFAULTSLOT 0
 SLOT 0 $8000
.ENDME

.ROMBANKSIZE $8000
.ROMBANKS 2

.SNESNATIVEVECTOR               ; Define Native Mode interrupt vector table
  COP EmptyHandler
  BRK EmptyHandler
  ABORT EmptyHandler
  NMI VBlank
  IRQ EmptyHandler
.ENDNATIVEVECTOR

.SNESEMUVECTOR                  ; Define Emulation Mode interrupt vector table
  COP EmptyHandler
  ABORT EmptyHandler
  NMI EmptyHandler
  RESET Start
  IRQBRK EmptyHandler
.ENDEMUVECTOR


.BANK 1 SLOT 0

.ORG $7F00
.SECTION "SETUP" SEMIFREE

.DEFINE REQUESTCODE = $FF00
	.db	$18
.DEFINE LOOPCOUNT = $FF01
	.db	$02
.DEFINE LOOPLENGTH = $FF02
	.dw	1800
.DEFINE LOOPSTART = $FF04
	.dw	600;900

Start:

	SEI

	CLC
	XCE

	REP	#$38		; A/Mem = 16 bit, X/Y = 16 bit, decimal = off

	LDX	#$1FFF		;Setup the stack
	TXS			;Transfer Index X to Stack Pointer Register

	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit

	JSL	$C70000

	LDA	REQUESTCODE
	STA	$1E01.b
	BPL	_BGM

	LDA	#$18
	STA	$1E00.b
	LDA	#$80

	BRA	_REQ
_BGM:
	LDA	#$10
	STA	$1E00.b
	LDA	#$FF
_REQ:
	STA	$1E02.b
	LDA	#$80
	STA	$1E03.b

	JSL	$C70004
	
	LDX	LOOPCOUNT.b	;[v

	CPX	#$00
	BEQ	_ILP

	REP	#$20		; A/Mem = 16 bit

	LDA	LOOPSTART.w

_CLP:	CLC
	ADC	LOOPLENGTH.w
	
	DEX
	BNE	_CLP

	STA	$1C00.w
	STZ	$1C02.w
	STZ	$1C04.w
	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit

	JSR	SetupVideo

	LDA	#$80
	STA	$4200		; Enable NMI
	
	CLI

_VLP:	WAI

	LDA	$1C02
	ORA	#$00

	BEQ	_VLP

	LDA	#$00
	STA	$4200		; Disable NMI

	LDA	#136
	STA	$2140
	LDA	#1
	STA	$2141

_ILP:	WAI
	BRA	_ILP

SetupVideo:

	LDA	#$00
	STA	$2105		; Set Video mode 1, 8x8 tiles, 16 color BG1/BG2, 4 color BG3

	LDA	#$04		; Set BG1's Tile Map offset to $0400 (Word address)
	STA	$2107		; And the Tile Map size to 32x32

	STZ	$210B		; Set BG1's Character VRAM offset to $0000 (word address)

	LDA	#$01		; Enable BG1
	STA	$212C

	LDA	#$0F
	STA	$2100		; Turn on screen, full Brightness

	RTS

VBlank:

	REP	#$20		; A/Mem = 16 bit
	PHA
	INC	$1C04.w		; VSYNC COUNTER
	LDA	$4210.w		; Clear NMI flag
	DEC	$1C00.w		; VSYNC COUNTER
	BNE	_SKIP
	LDA	#$0001
	STA	$1C02.w
_SKIP:	PLA
	SEP	#$20		; A/Mem = 8 bit
EmptyHandler:
	RTI

.ENDS


