.HIROM

.SNESHEADER
 ID    "FSSN"
 NAME  "FURAI NO SIRSNSF"
 HIROM
 FASTROM
 CARTRIDGETYPE $00
 ROMSIZE $0C
 SRAMSIZE $00
 COUNTRY $00
 LICENSEECODE $33
 VERSION $00
.ENDSNES

.MEMORYMAP
 SLOTSIZE $8000
 DEFAULTSLOT 0
 SLOT 0 $8000
.ENDME

.ROMBANKSIZE $8000
.ROMBANKS 2

.SNESNATIVEVECTOR               ; Define Native Mode interrupt vector table
  COP EmptyHandler
  BRK EmptyHandler
  ABORT EmptyHandler
  NMI VBlank
  IRQ EmptyHandler
.ENDNATIVEVECTOR

.SNESEMUVECTOR                  ; Define Emulation Mode interrupt vector table
  COP EmptyHandler
  ABORT EmptyHandler
  NMI EmptyHandler
  RESET Start
  IRQBRK EmptyHandler
.ENDEMUVECTOR


.BANK 1 SLOT 0

.ORG $7F00
.SECTION "SETUP" SEMIFREE

.DEFINE REQUESTCODE1 = $FF00
	.db	$00
.DEFINE REQUESTCODE2 = $FF01
	.db	$00

Start:
	SEI
	CLC
	XCE
	JMP	$80FF09

	REP	#$38		; A/Mem = 16 bit, X/Y = 16 bit, decimal = off

	LDX	#$1FFF		;Setup the stack
	TXS			;Transfer Index X to Stack Pointer Register

	LDA	#$0000
	TCD

	LDX	#$E000
_LP1:
	STA	$7E1FFE,X
	STA	$7F1FFE,X
	DEX
	DEX
	BNE	_LP1

	LDX	#$1FFE
_LP2:
	STA	$000000,X
	STA	$7F0000,X
	DEX
	DEX
	BNE	_LP2

	CLD

	JSL	$808086

	JSL	$818000

	JSL	$81800C

	REP	#$30
	LDA	$80FF00	;REQUESTCODE1
	STA	$00
	JSL	$818049

	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit

	JSR	SetupVideo

	LDA	#$80
	STA	$4200		; Enable NMI
	
	CLI

_VLP:
	WAI

	JSL	$81803A

	BRA	_VLP


SetupVideo:
	LDA	#$00
	STA	$2105		; Set Video mode 1, 8x8 tiles, 16 color BG1/BG2, 4 color BG3

	LDA	#$04		; Set BG1's Tile Map offset to $0400 (Word address)
	STA	$2107		; And the Tile Map size to 32x32

	STZ	$210B		; Set BG1's Character VRAM offset to $0000 (word address)

	LDA	#$01		; Enable BG1
	STA	$212C

	LDA	#$0F
	STA	$2100		; Turn on screen, full Brightness

	RTS

VBlank:
	REP	#$30
	PHB
	PHD
	PHA
	PHX
	PHY

;	JSL	$81803A

	REP	#$30
	LDA	$4210.w		; Clear NMI flag

	PLY
	PLX
	PLA
	PLD
	PLB

EmptyHandler:
	RTI

.ENDS


