.LOROM

.SNESHEADER
 ID    "OWSN"
 NAME  "OUTER WORLD SNSF"
 LOROM
 SLOWROM
 CARTRIDGETYPE $00
 ROMSIZE $0A
 SRAMSIZE $00
 COUNTRY $00
 LICENSEECODE $33
 VERSION $00
.ENDSNES

.MEMORYMAP
 SLOTSIZE $8000
 DEFAULTSLOT 0
 SLOT 0 $8000
.ENDME

.ROMBANKSIZE $8000
.ROMBANKS 1

.SNESNATIVEVECTOR               ; Define Native Mode interrupt vector table
  COP EmptyHandler
  BRK EmptyHandler
  ABORT EmptyHandler
  NMI NMIGATE
  IRQ EmptyHandler
.ENDNATIVEVECTOR

.SNESEMUVECTOR                  ; Define Emulation Mode interrupt vector table
  COP EmptyHandler
  ABORT EmptyHandler
  NMI EmptyHandler
  RESET RESETGATE
  IRQBRK EmptyHandler
.ENDEMUVECTOR


.BANK 0 SLOT 0

.ORG $7E00
.SECTION "SETUP" SEMIFREE

.DEFINE REQUESTCODE1 = $FE00
	.dw	$000A
.DEFINE REQUESTCODE2 = $FE02
	.dw	$0000

	JMP	RESETENTRY
	NOP

	JMP	NMIENTRY
	NOP

RESETGATE:
	JMP	$80FE04

NMIGATE:
	JMP	$80FE08

RESETENTRY:
	SEI

	CLC
	XCE

	REP	#$38		; A/Mem = 16 bit, X/Y = 16 bit, decimal = off

	LDA	#$07FF
	TCS

	LDA	#$0000
	TCD

	PHK
	PLB

	STZ	$2140
	STZ	$2142
	JSR	$86B5

	JSR	$E16B

	LDA	#$07FF
	TCS

	LDA	#$FFFF
	STA	$12

	LDA	REQUESTCODE1
	STA	$1E00
	LDA	$1E00

	CMP	#$0009
	BCC	_MTYPE2
	CMP	#$000C
	BCS	_MTYPE2

_MTYPE1:
	; for $09,$0A,s$0B
	STZ	$1D4E

	PEA	$0004
	PEA	$0000
	PEA	$0000
	JSR	$E848
	PLA
	JSR	$E1E8

	LDA	$1E00
	PHA
	JSR	$E307

	JMP	_MMAIN

_MTYPE2:

	STZ	$1D4E
	STZ	$0204

	PEA	$0004
	PEA	$0000
	PEA	$0000
	JSR	$E848
	PLA
	JSR	$E1E8

	LDA	$1E00
	PHA
	JSR	$E307

	JMP	_MMAIN

;copy of D458
	;JSR $C641
	;STZ $1D4E

	;PEA $0004
	;PEA $0000
	;PEA $0000
	;JSR $E848
	;PLA
	;JSR $E1E8

	;JSR $DFEA
	;TSC
	;STA $1D4A
	;STZ $0E64
	;JSR $DC1A

	;JSR $E022

;copy of D957
	;JSR $DA40

	;JSR $DDEE

	;PEA $008C
	;PEA $E5B7
	;JSR $DF0C

	;PEA $0204
	;PEA $008C
	;PEA $E52B
	;JSR $DF41

	;PEA $007F
	;PEA $0000
	;PEA $0000
	;PEA $8000
	;JSR $DBB2

	;PEA $0080
	;PEA $E875
	;PEA $0020
	;JSR $DBEB

	;SEP #$20

	;LDA #$01
	;STA $4200
	;LDX #$006A
	;STX $1D50
	;LDX #$0028
	;STX $1D52
	;LDX #$0001
	;STX $1D54 
	;LDA #$81
	;STA $4200

	;REP #$30

	;LDA $1E00
	;PHA
	;PEA $000A
	;JSR $E307
	;JSR $DFA5

	;BRA	_MMAIN

	;LDX	#$0034
	;LDA	#$0BE0
	;PHA
	;LDA	#$0000
	;PHA
	;PHA
	;JSR	$C125
	;JSR	$8A4C

	;BRA	_MMAIN

_MMAIN:
	SEP	#$30		; A/Mem = 8 bit, X/Y = 8 bit

	JSR	SetupVideo

	LDA	#$80
	STA	$4200		; Enable NMI
	
	CLI

_VLP:	WAI

	BRA	_VLP


SetupVideo:

	LDA	#$00
	STA	$2105		; Set Video mode 1, 8x8 tiles, 16 color BG1/BG2, 4 color BG3

	LDA	#$04		; Set BG1's Tile Map offset to $0400 (Word address)
	STA	$2107		; And the Tile Map size to 32x32

	STZ	$210B		; Set BG1's Character VRAM offset to $0000 (word address)

	LDA	#$01		; Enable BG1
	STA	$212C

	LDA	#$0F
	STA	$2100		; Turn on screen, full Brightness

	RTS

NMIENTRY:
	PHB
	PHK
	PLB
	REP	#$38		; A/Mem = 16 bit, X/Y = 16 bit, decimal = off
	PHA

	LDA	$4210.w		; Clear NMI flag

	PHX
	PHY
	PHD

	LDA	#$0000
	TCD

	LDA	$10
	BEQ	_SV
	LDA	$4218
_SV:
	STA	$0E50
	JSR	$8986


	PLD
	PLY
	PLX
	PLA
	PLB

EmptyHandler:
	RTI

.ENDS


